const DEFAULT_LISTENER_FROM_CORE = 25613;

const express = require('express');
const config = require('komodo-sdk/config');
const logger = require('komodo-sdk/logger');
const middlewareCommon = require('../middlewares/common');
const sender = require('./sender');

const app = express();

app.use(express.json({ extended: true }));
app.use(express.urlencoded({ extended: true }));

app.use((req, res, next) => {
    res.locals.httpgetx_subsystem = 'CORE-CALLBACK';
    next();
});

app.use(middlewareCommon);

app.use((req, res) => {
    res.end('OK');
    sender(req.query, res.locals.xid);
});

const port = (config.listener && config.listener.core && config.listener.core.port)
    || DEFAULT_LISTENER_FROM_CORE;

app.listen(port, () => {
    logger.info(`Listen from CORE callback on port ${port}`);
}).on('error', (e) => {
    logger.error(`Can not listen CORE callback on port ${port}. ${e.toString()}`);
    process.exit(1);
});
