const uuidv1 = require('uuid/v1');
const logger = require('komodo-sdk/logger');

module.exports = function common(req, res, next) {
    if (req.url.search('/favicon.ico') === 0) {
        res.sendStatus(404);
        return;
    }

    res.locals.xid = uuidv1();
    res.locals.x_http_request_ts = new Date();

    logger.info(`Got request from ${res.locals.httpgetx_subsystem === 'CORE-CALLBACK' ? 'CORE' : 'PARTNER'}`, {
        xid: res.locals.xid,
        pid: process.pid,
        requester_ip: req.ip,
        method: req.method,
        path: req.path,
        url: req.url,
        qs: req.query,
        body: req.body,
    });
    next();
};
